;dosstub.exe -- console applet that writes a tidy customized DOS stub to a PE.
;For use in build files.

comment| Sample build file for dosstub itself:
@echo off
\masm32\bin\ml /c /coff dosstub.asm
if errorlevel 1 goto end
\masm32\bin\Link /SUBSYSTEM:CONSOLE /STACK:4096 /HEAP:4096 dosstub.obj
del dosstub.obj
rem To apply dosstub to itself, we need to use a copy:
copy dosstub.exe dosstub$.exe /y
dosstub$ dosstub.exe
del dosstub$.exe
dir dosstub.exe
:end
|

.586
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib

.data
NewDosStub_ equ 80h
NewDosStub label byte
   db "MZ"    ;exe file signature
   dw 80h,1   ;exe size: bytes in last page, number of pages (rounded up).
   dw 0       ;exe relocation count
   dw 4       ;exe header size in paragraphs
   dw 1,1     ;extra paragraphs needed & wanted (just 1 to round up the allocation given by DOS)
   dw -10h,100h  ;initial ss, sp. ss=-10h gives ss=cs on entry
org 3Ch+NewDosStub
   dd 80h        ;file site of the letters "PE"
   db 0BAh,0Ch,1,0B4h,9,0CDh,21h,0B8h,1,4Ch,0CDh,21h
StubMessage$ label byte
org NewDosStub_+NewDosStub
PETable_ equ 78h
PETable label byte   ;we will read the incoming PE table to this site,
PESignature dd ?     ;and we give names to some of its many fields
    org 6+PETable
SectionCount dw ?
    org 18h+PETable
MagicNumber dw ?
    org 54h+PETable
SizeOfHeaders dd ?
    org 74h+PETable
DirsCount dd ?

hStdOut dd 0
hRead dd 0
hWrite dd 0
BlankFileSector dd 0      ;a mem handle
DirsSize dd ?
DirsCopy dd 0             ;a mem handle
SectionTableSize dd ?
SectionTable dd 0         ;a mem handle

FileNotFound$ db 16,"File not found",cr,lf
MZmissing$ db 24,"File does not begin MZ",cr,lf
BadPE$ db 73,"File is missing the PE signature or the optional header signature 0x10B",cr,lf
OutOfMemory$ db 15,"Out of memory",cr,lf
CantWrite$ db 21,"Write-access denied",cr,lf
CantExpandHeader$ db 50,"Nothing done -- no room in the PE header section",cr,lf
Usage$ db Usage_
    db "Usage: dosstub <filespec>",cr,lf
    db "Writes a custom DOS stub to a PE file.",cr,lf
Usage_ equ $-1-Usage$

ThisProgram$ db "This program"
ThisProgram_ equ $-ThisProgram$
StubText$ db " requires 32-bit Windows.",cr,lf,"$"
StubText_ equ $-StubText$

TailBegins dd ?
CmdLine db 80h dup (0)
Parm db 80h dup (0)

.code
BadPE: mov esi,offset BadPE$
   jmp short SayAndGo
usage: mov esi,offset Usage$
   jmp short SayAndGo
OutOfMemory: mov eax,offset OutOfMemory$
SayAndGo_eax: xchg eax,esi
SayAndGo: call WriteConsoleD1
quit: invoke ExitProcess,0

var1 equ dword ptr[ebp+8]     ;used with subroutines that begin "enter" or "push ebp / mov ebp,esp"
var2 equ dword ptr[ebp+12]

szCopy:     ;{dest,source}, Returns eax pointing at the zero in the new copy.
    push ebp
    mov ebp,esp
    push esi
    push edi
    mov edi,var1
    mov esi,var2
@@: lodsb
    stosb
    or al,al
    jnz @B
    xchg eax,edi
    dec eax
    pop edi
    pop esi
    pop ebp
    ret 8

WriteConsoleD1:   ;input is esi
    xor eax,eax
    lodsb
    push edx
    mov edx,esp
    invoke WriteConsoleA,hStdOut,esi,eax,edx,0
    pop eax
    ret

Start:
    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hStdOut,eax
    call GetCommandLine
    mov esi,offset CmdLine
    push eax
    push esi
    call szCopy
findparm:
    lodsb
    cmp al,0
    je usage
    cmp al," "
    je short gotspace
    cmp al,9         ;tab
    jne findparm
gotspace:
    lodsb
    cmp al," "
    je short gotspace
    cmp al,9
    je short gotspace
    cmp al,0
    je usage
    dec esi
    mov TailBegins,esi
copyparm: mov edi,offset Parm
findparmend:
    lodsb
    stosb
    cmp al,"\"
    je short copyparm
    cmp al,0
    je short gotparmend
    cmp al," "
    je short gotparmend
    cmp al,9
    jne short findparmend
gotparmend:
    cmp al,"\"
    je usage
    dec edi
    mov byte ptr[edi],0
    mov ecx,edi
    mov esi,offset Parm
    sub ecx,esi
    cmp ecx,24    ;max filespec size that will fit in the stub
    jna short @F
    mov esi,offset ThisProgram$
    mov ecx,ThisProgram_
@@: mov edi,offset StubMessage$
    rep movsb
    mov esi,offset StubText$
    mov ecx,StubText_
    rep movsb
    invoke CreateFileA,TailBegins,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
    inc eax
    mov esi,offset FileNotFound$
    jz SayAndGo
    dec eax
    mov hRead,eax
    push edx
    mov edx,esp
    push ecx        ;make a 4-byte read buffer on the stack
    mov ecx,esp     ;point at it
    invoke ReadFile,eax,ecx,2,edx,0
    pop eax
    pop edx
    mov esi,offset MZmissing$
    cmp ax,"ZM"
    jne SayAndGo
    invoke SetFilePointer,hRead,3Ch,0,0 ;get the offset of "PE"
    push eax         ;make room on the stack to dump the amount read
    mov edx,esp
    push eax         ;make a 4-byte read buffer
    mov ecx,esp
    invoke ReadFile,hRead,ecx,4,edx,0
    pop eax     ;what was read
    pop edx     ;amount read
    invoke SetFilePointer,hRead,eax,0,0  ;set file ptr to the location of "PE"
    inc eax
    jz BadPE
    push edx
    mov edx,esp
    invoke ReadFile,hRead,addr PETable,PETable_,edx,0
    pop edx
    cmp PESignature,"EP"
    jnz BadPE
    cmp MagicNumber,10Bh  ;a constant, denotes the presence of the section table etc.
    jnz BadPE
    mov eax,DirsCount
    shl eax,3
    mov DirsSize,eax
    xchg eax,esi
    invoke LocalAlloc,0,esi
    or DirsCopy,eax
    jz OutOfMemory
    push edx
    mov edx,esp
    invoke ReadFile,hRead,eax,esi,edx,0
    pop edx
    movzx eax,SectionCount
    shl eax,3    ;multiply eax by 8*5, which is the number of bytes in one section record
    lea eax,[eax+4*eax]
    mov SectionTableSize,eax
    xchg eax,esi
    invoke LocalAlloc,0,esi
    or SectionTable,eax
    jz OutOfMemory
    push edx
    mov edx,esp
    invoke ReadFile,hRead,eax,esi,edx,0
    pop edx
    invoke CloseHandle,hRead
    invoke LocalAlloc,40h,SizeOfHeaders ;a bunch of zeros, for padding the output file
    or BlankFileSector,eax              ;40h = LMEM_ZEROINIT = GMEM_ZEROINIT
    jz OutOfMemory
    mov eax,NewDosStub_+PETable_  ;if the current DOS stub is < 80h bytes, we
    add eax,DirsSize              ;   need to avoid enlarging it too much
    add eax,SectionTableSize
    cmp eax,SizeOfHeaders
    mov esi,offset CantExpandHeader$
    ja SayAndGo
    invoke CreateFileA,TailBegins,GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
    or hWrite,eax
    mov esi,offset CantWrite$
    jz SayAndGo      ;this could well happen, if say the PE is dll currently in use
    xchg eax,esi
    push edx
    mov edx,esp
    invoke WriteFile,esi,addr NewDosStub,NewDosStub_+PETable_,edx,0
    mov edx,esp
    invoke WriteFile,esi,DirsCopy,DirsSize,edx,0
    mov edx,esp
    invoke WriteFile,esi,SectionTable,SectionTableSize,edx,0
    pop edx
         ;we want to erase any debris in the PE file's header section:
    invoke SetFilePointer,esi,0,0,FILE_CURRENT   ;get current file pointer
    neg eax
    add eax,SizeOfHeaders
    push ecx
    mov ecx,esp
    invoke WriteFile,esi,BlankFileSector,eax,ecx,0
    pop eax
@@: invoke CloseHandle,hWrite      ;probably not necessary
    jmp quit

end Start
